
-- Funktion
Funktion = {};

function Funktion.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end;

function Funktion:load(xmlFile)

	self.updateSendEvent = SpecializationUtil.callSpecializationsFunction("updateSendEvent");

		local stuetze = {};
    stuetze.name = getXMLString(xmlFile, "vehicle.stuetze#name");
    stuetze.openSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.stuetze#upSpeedScale"), 1);
    stuetze.closeSpeedScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.stuetze#downSpeedScale"), -stuetze.openSpeedScale);
    if stuetze.name ~= nil then
        self.stuetze = stuetze;
    end;
	self.stuetze.active = false;
	

	local i=0;
    while true do
        local key = string.format("vehicle.animations.animation(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
            break;
        end;
        local name = getXMLString(xmlFile, key.."#name");
        if name ~= nil then		
			if name == "stuetze" then			
				local partKey = key..string.format(".part(%d)", 0);
				local loadTime = getXMLFloat(xmlFile, partKey.."#loadTime");
				local endTime = getXMLFloat(xmlFile, partKey.."#endTime");
				
				local currentTime = self:getAnimationTime(self.stuetze.name);
				local speed = 1;
				if currentTime > loadTime/endTime then
					speed = -1;
				end;
				self:playAnimation(self.stuetze.name, speed, currentTime, true);
				self:setAnimationStopTime(self.stuetze.name, loadTime/endTime);
				AnimatedVehicle.updateAnimations(self, 99999999);				
			end;
        end;
        i = i+1;
    end;
	
	self.jointmove = false;	
end;

function Funktion:delete()
end;

function Funktion:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Funktion:keyEvent(unicode, sym, modifier, isDown)
end;

function Funktion:readStream(streamId, connection)
	-- update animation on synchroninzation --
	local stuetzeAnimTime = streamReadFloat32(streamId);
	
	if stuetzeAnimTime ~= nil then
		local currentTime = self:getAnimationTime(self.stuetze.name);
		local speed = 1;
		if currentTime > stuetzeAnimTime then
			speed = -1;
		end;
		self:playAnimation(self.stuetze.name, speed, currentTime, true);
		self:setAnimationStopTime(self.stuetze.name, stuetzeAnimTime);	
	end;
	AnimatedVehicle.updateAnimations(self, 50);		

end;

function Funktion:writeStream(streamId, connection)
	streamWriteFloat32(streamId, self:getAnimationTime(self.stuetze.name));
end;

function Funktion:update(dt)
	
	local movejoint = self.jointmove;

	if self:getIsActiveForInput() then	
		
	
		local isstuetzeActive = false;
		if InputBinding.isPressed(InputBinding.Olmer_DOWN) then
		    self:playAnimation(self.stuetze.name, self.stuetze.openSpeedScale, self:getAnimationTime(self.stuetze.name)); 
			isstuetzeActive = true;	
			if InputBinding.hasEvent(InputBinding.Olmer_DOWN) then
				self:playAnimation(self.stuetze.name, self.stuetze.openSpeedScale, self:getAnimationTime(self.stuetze.name)); 
			end;			
		elseif InputBinding.isPressed(InputBinding.Olmer_UP) then
			self:playAnimation(self.stuetze.name, self.stuetze.closeSpeedScale, self:getAnimationTime(self.stuetze.name));
			isstuetzeActive = true;
			if InputBinding.hasEvent(InputBinding.Olmer_UP) then
				self:playAnimation(self.stuetze.name, self.stuetze.closeSpeedScale, self:getAnimationTime(self.stuetze.name));
			end;
		end
		if self.stuetze.active and not isstuetzeActive then
      		self:stopAnimation(self.stuetze.name);	
		end;
		self.stuetze.active = isstuetzeActive;
	end;
	
	if movejoint ~= self.jointmove then -- wenn gendert dann sende an server/client (minimierung der bertragungsrate) --
		self:updateSendEvent();
	end;
	

end;

function Funktion:updateTick(dt)
end;

function Funktion:draw()	

	g_currentMission:addExtraPrintText(InputBinding.getKeyNamesOfDigitalAction(InputBinding.Olmer_DOWN).." / "..InputBinding.getKeyNamesOfDigitalAction(InputBinding.Olmer_UP)..": Derouler/Enrouler");
	

end;

function Funktion:updateSendEvent()	

	if g_server ~= nil then
		g_server:broadcastEvent(MPEvent:new(self));
	else
		g_client:getServerConnection():sendEvent(MPEvent:new(self));
	end;

end;


